//+------------------------------------------------------------------+
//|                                        Tick_recorder_v1_test.mq4 |
//|                                                             Jake |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Jake"
#property link      ""
#property show_inputs
extern   string realfolder="real";
extern   string testfolder="test";
int         fh;
datetime    lasttime;
double      volume,lastvolume;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
//----
   if(StringLen(StringTrimRight(realfolder))==0)realfolder="real";
   if(StringLen(StringTrimRight(testfolder))==0)testfolder="test";
   lasttime=StrToTime(TimeYear(TimeCurrent()-DayOfWeek()*60*60*24)+"."+TimeMonth(TimeCurrent()-DayOfWeek()*60*60*24)+"."+TimeDay(TimeCurrent()-DayOfWeek()*60*60*24));
//   Print(TimeToStr(lasttime,TIME_DATE));
   if(IsTesting())
   {
      fh=FileOpen(file_name()+"_ticks.tic",FILE_WRITE|FILE_BIN);
      FileClose(fh);
   }
   fh=FileOpen(file_name()+"_ticks.tic",FILE_WRITE|FILE_READ|FILE_BIN);
   if(fh==-1) {Print("cannot open file");return(-1);}
   bool b=FileSeek(fh,0,SEEK_END); 
   lastvolume=Volume[0];
//----
   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   FileFlush(fh);
   FileClose(fh);      
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
   if(fh==-1) {Print("no file");return(-1);}
   datetime currenttime=StrToTime(TimeYear(TimeCurrent()-DayOfWeek()*60*60*24)+"."+TimeMonth(TimeCurrent()-DayOfWeek()*60*60*24)
   +"."+TimeDay(TimeCurrent()-DayOfWeek()*60*60*24));
   if(lasttime<currenttime)
   {
      lasttime=currenttime;
      FileFlush(fh);
      FileClose(fh);
      if(IsTesting())
      {
         fh=FileOpen(file_name()+"_ticks.tic",FILE_WRITE|FILE_BIN);
         FileClose(fh);
      }
      fh=FileOpen(file_name()+"_ticks.tic",FILE_WRITE|FILE_READ|FILE_BIN);
   }         
//----
   if(lastvolume>Volume[0])
   {
      lastvolume=Volume[0];
      volume=Volume[0];
   }
   else
   {
      volume=Volume[0]-lastvolume;
      lastvolume=Volume[0];
   }
   if(volume==0)volume=1;
   int k=FileWriteInteger(fh,TimeCurrent());
   int l=FileWriteDouble(fh,Bid);
   int m=FileWriteDouble(fh,Ask);
   int n=FileWriteDouble(fh,volume);
//   Print("ticksize=",volume);
//----
   return(0);
}
string file_name()
{
   int day1,month1;
   string year=TimeYear(lasttime);
   month1=TimeMonth(lasttime);
   if(month1<10)string month="0"+month1; else month=month1;
   day1=TimeDay(lasttime);
   if(day1<10)string day="0"+day1; else day=day1;
   string filename=(Symbol()+StringTrimRight("\\ ")+year+StringTrimRight("\\ ")+Symbol()+year+month+day);
   if(IsTesting())
   {
      filename=StringTrimRight(testfolder+"\\ ")+filename;
   }
   else
   {
      filename=StringTrimRight(realfolder+"\\ ")+filename;
   }
   return(filename);
}
//+------------------------------------------------------------------+